grk::HWY_NAMESPACE Namespace Reference

## Classes

class | CompressIrrev
| Apply MCT with optional DC shift to irreversible compressed image. More...
class | CompressRev
| Apply MCT with optional DC shift to reversible compressed image. More...
class | DecompressDcShiftIrrev
| Apply dc shift for irreversible decompressed image. More...
class | DecompressDcShiftRev
| Apply dc shift for reversible decompressed image (assumes mono with no MCT) input and output buffers are both 32 bit integer. More...
class | DecompressIrrev
| Apply MCT with optional DC shift to irreversible decompressed image. More...
class | DecompressRev
| Apply MCT with optional DC shift to reversible decompressed image. More...

## Functions

template<class T >
void | vscheduler (ScheduleInfo info)
void | hwy_compress_rev (ScheduleInfo info)
void | hwy_compress_irrev (ScheduleInfo info)
void | hwy_decompress_rev (ScheduleInfo info)
void | hwy_decompress_irrev (ScheduleInfo info)
void | hwy_decompress_dc_shift_irrev (ScheduleInfo info)
void | hwy_decompress_dc_shift_rev (ScheduleInfo info)
static size_t | hwy_num_lanes (void)
static void | hwy_decompress_v_final_memcpy_53 (const int32_t *buf, const uint32_t height, int32_t *dest, const size_t strideDest)
static void | hwy_decompress_v_parity_even_mcols_53 (int32_t *buf, int32_t *bandL, const uint32_t hL, const size_t strideL, int32_t *bandH, const uint32_t hH, const size_t strideH, int32_t *dest, const uint32_t strideDest)
| Vertical inverse 5x3 wavelet transform for 8 columns in SSE2, or 16 in AVX2, when top-most pixel is on even coordinate.
static void | hwy_decompress_v_parity_odd_mcols_53 (int32_t *buf, int32_t *bandL, const uint32_t hL, const uint32_t strideL, int32_t *bandH, const uint32_t hH, const uint32_t strideH, int32_t *dest, const uint32_t strideDest)
| Vertical inverse 5x3 wavelet transform for 8 columns in SSE2, or 16 in AVX2, when top-most pixel is on odd coordinate.

## Function Documentation

## hwy_compress_irrev()

void grk::HWY_NAMESPACE::hwy_compress_irrev | ( | ScheduleInfo | info | ) |

References grk::grk_read().

## hwy_compress_rev()

void grk::HWY_NAMESPACE::hwy_compress_rev | ( | ScheduleInfo | info | ) |

References grk::grk_read().

## hwy_decompress_dc_shift_irrev()

void grk::HWY_NAMESPACE::hwy_decompress_dc_shift_irrev | ( | ScheduleInfo | info | ) |

References grk::grk_read().

## hwy_decompress_dc_shift_rev()

void grk::HWY_NAMESPACE::hwy_decompress_dc_shift_rev | ( | ScheduleInfo | info | ) |

References grk::grk_read().

## hwy_decompress_irrev()

void grk::HWY_NAMESPACE::hwy_decompress_irrev | ( | ScheduleInfo | info | ) |

References grk::grk_read().

## hwy_decompress_rev()

void grk::HWY_NAMESPACE::hwy_decompress_rev | ( | ScheduleInfo | info | ) |

References grk::grk_read().

## hwy_decompress_v_final_memcpy_53()

static void grk::HWY_NAMESPACE::hwy_decompress_v_final_memcpy_53 | ( | const int32_t * | buf,
|  | const uint32_t | height,
|  | int32_t * | dest,
|  | const size_t | strideDest
| ) |  |

static

References grk::grk_read(), HWY_FULL, HWY_PLL_COLS_53, hwy::HWY_NAMESPACE::Lanes(), hwy::HWY_NAMESPACE::Load(), and hwy::HWY_NAMESPACE::StoreU().

Referenced by hwy_decompress_v_parity_even_mcols_53(), and hwy_decompress_v_parity_odd_mcols_53().

## hwy_decompress_v_parity_even_mcols_53()

static void grk::HWY_NAMESPACE::hwy_decompress_v_parity_even_mcols_53 | ( | int32_t * | buf,
|  | int32_t * | bandL,
|  | const uint32_t | hL,
|  | const size_t | strideL,
|  | int32_t * | bandH,
|  | const uint32_t | hH,
|  | const size_t | strideH,
|  | int32_t * | dest,
|  | const uint32_t | strideDest
| ) |  |

static

Vertical inverse 5x3 wavelet transform for 8 columns in SSE2, or 16 in AVX2, when top-most pixel is on even coordinate.

References grk::grk_read(), hwy_decompress_v_final_memcpy_53(), HWY_FULL, HWY_PLL_COLS_53, hwy::HWY_NAMESPACE::Lanes(), hwy::HWY_NAMESPACE::LoadU(), hwy::HWY_NAMESPACE::Set(), and hwy::HWY_NAMESPACE::Store().

## hwy_decompress_v_parity_odd_mcols_53()

static void grk::HWY_NAMESPACE::hwy_decompress_v_parity_odd_mcols_53 | ( | int32_t * | buf,
|  | int32_t * | bandL,
|  | const uint32_t | hL,
|  | const uint32_t | strideL,
|  | int32_t * | bandH,
|  | const uint32_t | hH,
|  | const uint32_t | strideH,
|  | int32_t * | dest,
|  | const uint32_t | strideDest
| ) |  |

static

Vertical inverse 5x3 wavelet transform for 8 columns in SSE2, or 16 in AVX2, when top-most pixel is on odd coordinate.

References grk::grk_read(), hwy_decompress_v_final_memcpy_53(), HWY_FULL, HWY_PLL_COLS_53, hwy::HWY_NAMESPACE::Lanes(), hwy::HWY_NAMESPACE::LoadU(), hwy::HWY_NAMESPACE::Set(), and hwy::HWY_NAMESPACE::Store().

## hwy_num_lanes()

static size_t grk::HWY_NAMESPACE::hwy_num_lanes | ( | void |  | ) |

static

References grk::grk_read(), HWY_FULL, and hwy::HWY_NAMESPACE::Lanes().

## vscheduler()

template<class T >

void grk::HWY_NAMESPACE::vscheduler | ( | ScheduleInfo | info | ) |

References ExecSingleton::get(), and grk::grk_read().